#pragma once

#include <list>
#include <mutex>

#include "memory_utils.h"
#include "region.h"
#include "types.h"



/* A memory pool abstraction. */

class Memory
{
protected:
    std::mutex _lock;

    unsigned int _limit;
    offset_t _region_size;
    bool _limited;

public:
    explicit Memory(unsigned int limit, offset_t region_size=PAGE_SIZE);

    explicit Memory();

    Region *allocate(offset_t size);

    Region *region(offset_t size);

    Region *region();

    void release(Region *region);
};

// vim: tabstop=4 expandtab shiftwidth=4
